package baldr;

import org.apache.lucene.document.Document;
import org.apache.lucene.document.Field;

public class Gov2Document {

	private Document document;

	private String docno;
	private String headline;
	private String uri;
	private Field f;

	public Gov2Document(String docno, String headline, String uri, String text) {
		/*
		 * docno --> GX000-00-0004674
		 * headline --> title
		 * uri --> uri
		 * text --> content
		 */
		document = new Document();
		this.docno = docno;
		this.headline = headline;
		this.uri = uri;
		Field headlineField = new Field("headline", headline, Field.Store.YES, Field.Index.TOKENIZED);
		headlineField.setBoost(2.0f);

		document.add(new Field("docno", docno, Field.Store.YES,
				Field.Index.UN_TOKENIZED));
		document.add( headlineField );
		document.add(new Field("uri", uri, Field.Store.YES,
				Field.Index.TOKENIZED));
		document.add(new Field("text", text, Field.Store.NO,
				Field.Index.TOKENIZED));
	}
	
	public void newDoc() {
		this.document = new Document();
	}
	
	public void setHeadline(String headline) {
		
	}
	
	public void setDocno(String docno) {
		
	}
	
	public void setUri(String uri) {
		
	}
	
	public void setText(String text) {
		
	}

	public Document document() {
		return document;
	}

	public String getDocno() {
		return this.docno;
	}
	
	public String getUri() {
		return this.uri;
	}

	public String getHeadline() {
		return this.headline;
	}
}
