package baldr;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.Reader;
import java.util.HashSet;

import org.apache.lucene.analysis.Analyzer;
import org.apache.lucene.analysis.SimpleAnalyzer;
import org.apache.lucene.analysis.Token;
import org.apache.lucene.analysis.TokenFilter;
import org.apache.lucene.analysis.TokenStream;
import org.apache.lucene.analysis.standard.StandardAnalyzer;


/*
 * This analyzer will contain the Tokenizer and filters which will take as input 
 * the text-stream from the unparsed documents, and so create filtered bigram's 
 * without stopword removal.
 * 
 * Hopefully there will be som improvements in terms of precision and recall. 
 * The index size will however be quite larger though.
 */
public class NGramAnalyzer extends Analyzer {
	private static final HashSet<String> ENGLISH_STOP_WORDS = new HashSet<String>();
	
	public NGramAnalyzer() {
		init_stopWords();
	}
	
	private void init_stopWords() {
		try {
			File tmpFil = new File("/home/fellingh/stop_words.txt");
			BufferedReader in = new BufferedReader(new FileReader(tmpFil));
			String tmpWord;
			while((tmpWord = in.readLine()) != null) {
				if(tmpWord.startsWith("#") || tmpWord.startsWith(" ")){
					continue;
				}
				ENGLISH_STOP_WORDS.add(tmpWord);
			}
			in.close();
		} catch(IOException e) {
			e.printStackTrace();
		}
	}
	
	public TokenStream tokenStream(String fieldName, final Reader reader) {
		return new SimpleAnalyzer().tokenStream(fieldName, reader);
	}
	
	private static class NGramFilter extends TokenFilter {
		public NGramFilter(TokenStream input) {
			super(input);
		}
		
		public final Token next() {
			return new Token("sd",0,0);
		}
	}
}
