package baldr;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Vector;

import org.apache.commons.lang.StringUtils;

public class ParseBadTrec {
	/* katalog der dokumentene som skal indekseres befinner seg. */
	private static String baseDir = "/home/fellingh/skole/LuceneBase";
	private static String newBaseDir = "/home/fellingh/skole/LuceneBase_clean";
	private static boolean debug = false;
	private boolean collect = false;
	private int numDocsParse = 250;
	private int numDocs = 0;
	private int newFileNumber = 0;
	private File[] files;
	private ArrayList<BadTrecDocument> documents = new ArrayList<BadTrecDocument>();
	
	public ParseBadTrec() {
		//Object f = new File(baseDir);
		files = new File(baseDir).listFiles();
	}
	
	public void start() {
		BufferedReader in;
	    String line, tmpDoc = "";
	    Vector<String> tdoc = new Vector<String>();
	    
	    System.out.println("Has "+files.length+" files to parse..");
	    for(File f : files) {
	        /*
	         * Hent hver fil og XML-parse dem!
	         * 
	         * For hver <doc> lag et nytt Trec96Document!
	         * Samle alle Trec96Document, og indekser dem!
	         */
	    	
	    	/*
	    	if(!"/home/fellingh/skole/LuceneBase/aaa/cr93e45".equals(f.getAbsolutePath())) {
	    		continue;
	    	}*/
	    	
	        System.out.println("Leser fil: "+f.getAbsolutePath());
	    	if(f.isDirectory()) {
	    		System.out.println("\t"+f.getName()+" is a directory. Skipping!");
	    		continue;
	    	}
	    	
	    	if(debug) {
		    	/* for å slippe å vente sååå jævli lenge */
	    	}
	    	
	        try {
	            in = new BufferedReader(new FileReader(f));
	            
	            while((line = in.readLine()) != null) {
	                tdoc.addElement( (String)line);
	            }
	            in.close();
	            
	        } catch(IOException e) {
	            System.out.println("Fikk ikke lest: "+f.getAbsolutePath());
	            e.printStackTrace();
	        }
	        indexTrecFile(tdoc);
	        tdoc.clear();
	        numDocs++;
	        
	    }
	    /*
	    this.parsing = false;
	    this.indexer.doneParsing(this.numDocs);
	    */
	}
	
	private void indexTrecFile(Vector data) {
        
        String tmpString = "";
        //StringBuilder tmpString2 = new StringBuilder()
        BadTrecDocument tmpTrec;
        boolean aDoc = false;
        String docno="", headline="", date="", text = "";
        Enumeration<String> vdoc = data.elements();
        
        //System.out.println("Parsing file with "+data.size()+" data elements..");
        
        while(vdoc.hasMoreElements()) {
        	if(debug) {
	         	/* for å slippe å vente sååå jævli lenge */
	        	//if(tmpdocs >= maxdocs) break;
        	}
        	
            try {
                tmpString = (String) vdoc.nextElement();
                //tmpString (String) data.elements().
                if ("<DOC>".equals(tmpString)) {
                    //tmpTrec = new Trec96Document();
                    aDoc = true;
                    //System.out.println("We got a <DOC>! Has now "+documents.size()+" docs in thread!");
                } else if ("</DOC>".equals(tmpString)) {
                    /* Valider at vi har docno, docid, date og text. */
                    //System.out.println("We got a stop </DOC>");
                    aDoc = false;
                    boolean ok = true;
                    
                    if ("".equals(docno)) System.out.println("No docno");
                    else if ("".equals(headline)) {
                    	System.out.println("No headline");
                    }
                    else if ("".equals(date)) System.out.println("No date!");
                    else if ("".equals(text)) System.out.println("No text");
                    else {
                        //System.out.println("Har et OK TREC dokument!");
                        tmpTrec = new BadTrecDocument(docno, headline, text, date);
                        documents.add(tmpTrec);
                        tmpTrec = null;
                        docno="";
                        headline=""; 
                        date="";
                        text="";
                        
                        if(debug) {
	                        /* for å ikke vente såå jævli lenge! */
	                        //tmpdocs++;
                        }
                        
                        if(documents.size() >= this.numDocsParse) {
                            this.collect = true;
                            while(this.collect == true) {
                                try {
                                    //System.out.println("TrecParser: Tømmer buffre.. Antall filer: "+this.numDocs+" Antall docs: "+documents.size());
                                    //System.out.println("Venter p at TestSearch2 skal indeksere..");
                                	
                                	/* This magic method iterates over all documents, and writes them to 
                                	 * the filesystem as regular files. 
                                	 */
                                	writeNewTrecFiles();

                                	this.collect = false;
                                } catch(Exception e) {
                                    e.printStackTrace();
                                }
                            }
                        }
                        continue;
                    }
                }
                
                if (aDoc) {
                    /* Er mellom <DOC> og </DOC>. Parser etter:
                     * <DOCNO> </DOCNO>
                     * <DATE> </DATE>
                     * <TTL> </TTL>
                     * <TEXT> >/TEXT>
                     */
                    if (tmpString.startsWith("<DOCNO>")) {
                        int startpos = tmpString.indexOf("<DOCNO>")+"<DOCNO>".length();
                        int stoppos = tmpString.indexOf("</DOCNO>");
                        docno = tmpString.substring(startpos, stoppos);
                        //System.out.println("Satte docno! "+docno);
                    } else if (tmpString.startsWith("<DATE>")) {
                        int startpos = tmpString.indexOf("<DATE>")+"<DATE>".length();
                        int stoppos = tmpString.indexOf("</DATE>");
                        
                        /* Sometimes the </DATE> thing is at the nextline.. FUCKÌNGS TREC! */
                        if(stoppos == -1) {
                        	stoppos = tmpString.length();
                        }
                        
                        date = tmpString.substring(startpos, stoppos);
                        //System.out.println("Satte date! "+date);
                    } else if (tmpString.startsWith("<HEADLINE>")) {
                        // headline kan vre flere linjer..
                        //System.out.println("Setter headline! "+tmpString);
                        String htemp = "";
                        while(vdoc.hasMoreElements()) {
                            htemp = (String)vdoc.nextElement();
                            if (!htemp.startsWith("</HEADLINE>")) {
                                headline = headline+" "+htemp;
                                htemp = "";
                            } else {
                                break;
                            }
                        }
                    }  else if ("<TEXT>".equals(tmpString)) {
                    	/*
                    	 * Denne kodensnutten her kjører helt til hele seksjonen innkapslet 
                    	 * i <TEXT>(.*)</TEXT> er lest! 
                    	 */
                    	
                        //System.out.println("Setter text!");
                        String ttemp = "";
                        while(vdoc.hasMoreElements()) {
                            ttemp = (String)vdoc.nextElement();
                            if (ttemp.startsWith("<TTL>")) {
                            	int startpos = ttemp.indexOf("<TTL>")+"<TTL>".length();
                            	int stoppos = ttemp.indexOf("</TTL>");
                            	headline = ttemp.substring(startpos, stoppos);
                            	//System.out.println("Satte headline til: "+headline);
                            }
                            
                            if (!ttemp.startsWith("</TEXT>")) {
                            	/* Parse out all the <TAG>....</TAG> crap! */
                            	text = text+" "+removeBadTags(ttemp);
                                ttemp = "";
                            } else {
                                break;
                            }
                        }
                    } else if (tmpString.startsWith("<TTL>")) {
                    	/*
                    	 * I dok cr93hXX så finnes <TTL> utenfor <TEXT>(.*)>/TEXT>..
                    	 * Utrolig teit format på TREC filene..
                    	 * */
                    	int startpos = tmpString.indexOf("<TTL>")+("<TTL>").length();
                    	int stoppos = tmpString.indexOf("</TTL>");
                    	headline = tmpString.substring(startpos, stoppos);
                    	//System.out.println("Satte (TTL) hHeadline2");
                    } else {
                    	/*
                        System.out.println(">>>> Rart.. <<<<");
                        System.out.println(tmpString);
                        */ 
                    }
                }
            } catch (Exception e) {
                System.out.println("Objekt hentet fra vektor er ikke tekst.");
                e.printStackTrace();
            }
        } // Ingen flere elementer i vektoren!
        
        

        
        this.collect = true;
        while(this.collect == true) {
            try {
            	writeNewTrecFiles();
            	this.collect = false;
            } catch(Exception e) {
                e.printStackTrace();
            }
        }
        
        /*
        for(int i=0;i<documents.size(); i++) {
            System.out.println("Docno: "+documents.get(i).getDocno());
            System.out.println("Headline: "+documents.get(i).getHeadline());
        }*/
    }
    
    private String removeBadTags(String str) {
    	/*
    	 * There is a lot over weird tags in this TREC files, to we just simply 
    	 * filters those out. Don't want to index something that dosn't have any 
    	 * semantic value.
    	 */
    	String[] badTags = {"<H2>","</H2>","<PRE>","</PRE>","<CENTER>","</CENTER>",
    			"<FLD001>","</FLD001>","<FLD002>","</FLD002>","<TI>","</TI>", 
    			"<SO>","</SO>","<UL>","</UL>","<TTL>","</TTL>"};
    	String retval = str;
    	for(int i=0;i<badTags.length; i++) {
    		retval = StringUtils.remove(retval, badTags[i]);
    	}
    	return retval;
    }
    
    private void writeNewTrecFiles() {
    	/*
    	 * When a chunk of TREC files have been parsed, this should be runned!
    	 * NOTE: This method is called multiple times, so that we can reset the internal
    	 * document structure.
    	 * 
    	 * NOTE: We collect 400 TREC docs in one physical file
    	 */
    	File outFile;
    	FileWriter writer;
    	BufferedWriter buffer = null;
    	int docCount=0;
    	int maxCount=400;
    	//System.out.println("Start writing new files..");
    	try {
    		if(documents.size() == 0) throw new Exception("Are none documents to process");
    		
    		for(BadTrecDocument doc : documents) {
    			if((docCount >= maxCount) || (buffer == null)) {
    				/* Create new file (path+/+X.txt) */
    				if (buffer != null) {
    					buffer.close();
    					newFileNumber++;
    				}
    				System.out.println("Creates new output file: "+newBaseDir+File.separator+newFileNumber+".txt");
    				outFile = new File(newBaseDir+File.separator+newFileNumber+".txt");
    				writer = new FileWriter(outFile);
    				buffer = new BufferedWriter(writer);
    				docCount = 0;
    			} else {
    				/* Continue to write on  */
    				docCount++;
    			}
    			
    			//System.out.println("docCount: "+docCount+". newFileNumber: "+newFileNumber);
    			buffer.write("<doc>");
				buffer.write("\t<docno>"+doc.getDocno()+"</docno>");
				buffer.newLine();
				buffer.write("\t<date>"+doc.getDate()+"</date>");
				buffer.newLine();
				buffer.write("\t<headline>"+doc.getHeadline()+"</headline>");
				buffer.newLine();
				buffer.write("\t<content>"+doc.getContent()+"</content>");
				buffer.newLine();
				buffer.write("</doc>");
				buffer.newLine();
    		}
    		newFileNumber++;
    		
    	} catch(Exception e) {
    		e.printStackTrace();
    	} finally {
    		//System.out.println("Flushing documents..");
    		documents.clear();
    	}
    	
    	/* Memory debugging */
    	/*
    	long mem = Runtime.getRuntime().totalMemory()-Runtime.getRuntime().freeMemory();
    	System.out.println("Using "+mem+" bytes of memory.. Running garbage collection..");
    	Runtime.getRuntime().gc(); */
    }
	
}
