package baldr;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;

import it.unimi.dsi.mg4j.document.CompositeDocumentFactory;
import it.unimi.dsi.mg4j.document.Document;
import it.unimi.dsi.mg4j.document.DocumentFactory;
import it.unimi.dsi.mg4j.document.DocumentIterator;
import it.unimi.dsi.mg4j.document.HtmlDocumentFactory;
import it.unimi.dsi.mg4j.document.PropertyBasedDocumentFactory;
import it.unimi.dsi.mg4j.document.TRECDocumentCollection;
import it.unimi.dsi.mg4j.document.TRECHeaderDocumentFactory;
import it.unimi.dsi.mg4j.io.FastBufferedReader;
import it.unimi.dsi.mg4j.util.MutableString;
import it.unimi.dsi.mg4j.util.Properties;



public class TestGov2Reader {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws IOException {
		long timeStart = System.currentTimeMillis();
		
		Properties p = new Properties();
	    TRECHeaderDocumentFactory thd = new TRECHeaderDocumentFactory();
	    HtmlDocumentFactory hdf;
	    DocumentFactory docFac = null;
	    TRECDocumentCollection d;
	    int numDocs = 0;
	    int maxNumDocs = 5000;
	    int maxFiles = 10;
	    
	    
	    File dir = new File("/home/fellingh/skole/trec_gov2/GX000");
        if (! dir.exists()) {
            return ;
        }
        
        File[] filer = dir.listFiles();
        ArrayList<String> files = new ArrayList<String>();
        int numFiles = 0;
        for(File f : filer) {
        	if(f.isDirectory()) continue;
        	files.add(f.getAbsolutePath());
        	if (numFiles >= maxFiles) break;
        	numFiles++;
        }
	    
	    
	    try {
        	p.addProperty(PropertyBasedDocumentFactory.MetadataKeys.ENCODING, new String("ISO-8859-1"));
        	hdf = new HtmlDocumentFactory( p );
        	DocumentFactory[] facArray = {thd, hdf};
        	docFac = CompositeDocumentFactory.getFactory(facArray, new String[] {"text","title","anchor"});
        }catch(Exception e) {
        	e.printStackTrace();
        }
	    
	    String[] gov2File = getFilelistArray(files);
	    
		d = new TRECDocumentCollection(gov2File, docFac, 8192, false);
    	Document dt;        	
    	DocumentIterator it = d.iterator();
    	MutableString title = new MutableString();
    	MutableString content = new MutableString();
    	FastBufferedReader r;
    	MutableString parsedContent;
    	int c;
    	char l, prev;
    	
    	do {
    		parsedContent = new MutableString();    		
    		dt = it.nextDocument();
    		if (dt==null) break;

    		
    		r = (FastBufferedReader) dt.content(0);
    		r.readLine(content);
    		prev = ' ';
    		while( (c = r.read()) != -1) {
    			l = (char) c;
    			if (prev == ' ' && l == ' ') continue; /* vil ikke ha repeterende mellomrom! */
    			if (l == '\n' || l == '\r' || l=='\t') {
    				continue;
    			}
    			parsedContent.append(l);
    			prev = l;
    		}

    		r = (FastBufferedReader) dt.content(1);
    		numDocs++;
    		/*
    		if(numDocs >= maxNumDocs) {
    			break;
    		} */
    	} while(true); // continues until the iterator returns null!
    	
    	
    	long timeStop = System.currentTimeMillis();
        long timeItTook = (timeStop - timeStart)/1000;

        int seconds=0;
		int minutes=0;
		
		if (timeItTook > 60) {
			minutes = ((int)timeItTook) / 60;
			seconds = ((int)timeItTook)-(minutes*60);
		} else {
			seconds = (int)timeItTook;
		}
		System.out.println("Det tok "+minutes+" mins and "+seconds+" secs å indeksere.");
        System.out.println("Har lest "+files.size()+" filer, og "+numDocs+" GOV2 docs.");
        System.out.println("timeItTook: "+(timeStop-timeStart));
        System.out.println("Ferdig med  indeksere!\n===========================\n");
	}
	
	public static String[] getFilelistArray(ArrayList<String> files) {
    	MutableString tmp = new MutableString();
    	String filesString;
    	String[] filesArray;
    	
    	int x = 1;
    	for(String fil : files) {
    		if (x==files.size()) {
    			tmp.append(fil);
    		} else {
    			tmp.append(fil+" ");
    		}
    		x++;
    	}
    	filesString = tmp.toString();    	
    	filesArray = filesString.split(" ");

    	
    	 return filesArray;
    }

}
