package baldr.utility;

import java.util.Collection;
import java.util.Formatter;
import java.util.Hashtable;
import java.util.List;

import org.apache.lucene.document.Field;
import org.apache.lucene.index.IndexReader;
import org.apache.lucene.index.Term;
import org.apache.lucene.index.TermDocs;
import org.apache.lucene.index.TermEnum;
import org.apache.lucene.index.IndexReader.FieldOption;
import org.apache.lucene.search.IndexSearcher;
import org.apache.lucene.store.Directory;
import org.apache.lucene.store.FSDirectory;
import org.apache.lucene.util.PriorityQueue;

import baldr.Definitions;


public class HighFrequentTerms {
    public static void main(String[] args) throws Exception {
        // Print out high frequent terms!
    	
    	if(args.length > 0) {
    		System.out.println("Index path: "+args[0]);
    	} else {
    		System.out.println("Need index path as argument! Will quit.");
    		System.exit(0);
    	}
    	
    	
        
        int numTerms = 102;
        /*
        StringBuilder sb = new StringBuilder();
        Formatter formatter = new Formatter(sb);
        formatter.format("%1$1s: %2$3s %3$12s",1, "www", 44000);
        System.out.println(sb);
        
        
        sb.delete(0, sb.length());
        formatter.format("%1$1s: %2$3s %3$12s",2, "LOL", 8000);
        System.out.println(sb);
        */
        
        
        Directory directory = FSDirectory.getDirectory(args[0]);
        IndexSearcher isearcher = new IndexSearcher(directory);
        IndexReader ireader = isearcher.getIndexReader();
        
        /*
        Collection<String> l = ireader.getFieldNames(FieldOption.ALL);
        String[] fields = {"headline","text"};
        for(String t : l) {
            System.out.println("Field: "+t);
        }*/
        
        TermInfoQueue tiq = new TermInfoQueue(numTerms);
        TermEnum terms = ireader.terms();
        TermDocs termDocs = null;
        Term term = null;
        String field;
        
        int minFreq = 0;
        int termFreq = 0;
        
        while(terms.next()) {
            field = terms.term().field();
            //term = terms.term();
            
            termDocs = ireader.termDocs(terms.term());
            while(termDocs.next()) {
            	termFreq += termDocs.freq();
            } 
            
            if(terms.docFreq() > minFreq) {
                //tiq.put(new TermInfo(terms.term(), terms.docFreq()));
                tiq.put(new TermInfo(terms.term(), termFreq));
                if(tiq.size() >= numTerms) {
                    tiq.pop();
                    minFreq = ((TermInfo)tiq.pop()).docFreq;
                }
            }
            termFreq = 0;
        }
        
        TermInfo[] res = new TermInfo[tiq.size()];
        for(int i=0;i<res.length;i++) {
            res[res.length - i - 1] = (TermInfo) tiq.pop();
        }
        ireader.close();
        System.out.println("Antall res: "+res.length);
        int x=0;

        StringBuilder sb = new StringBuilder();
        //Formatter formatter = new Formatter(sb);
        //formatter.format("%1$1s: %2$3s %3$12s",1, "www", 44000);
        for(TermInfo ti : res) {
            x++;
            //System.out.println(x+": "+ti.term.text()+"\t\tFreq: "+ti.docFreq);
            sb.append(x);
            sb.append(": ");
            sb.append(ti.term.field());
            sb.append(":");
            sb.append(ti.term.text());
            sb.append("\t\tFreq: ");
            sb.append(ti.docFreq);
            System.out.println(sb);
            sb.delete(0, sb.length());
            /*
            formatter.format("%1$1s: %2$3s %3$12s",x, ti.term.text(), ti.docFreq);
            System.out.println(sb);
            sb.delete(0, sb.length());*/
        }
    }
}

final class TermInfoQueue extends PriorityQueue {
    public TermInfoQueue(int size) {
        initialize(size);
    }
    
    protected final boolean lessThan(Object a, Object b) {
        TermInfo termInfoA = (TermInfo) a;
        TermInfo termInfoB = (TermInfo) b;
        
        return termInfoA.docFreq < termInfoB.docFreq; 
    }
}
final class TermInfo {
    int docFreq;
    Term term;
    
    public TermInfo(Term t, int df) {
        term = t;
        docFreq = df;
    }
}
