package baldr.utility;

import java.io.BufferedOutputStream;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Map;
import java.util.Properties;
import org.apache.lucene.index.*;
import org.apache.lucene.store.Directory;
import org.apache.lucene.store.FSDirectory;
import org.apache.lucene.analysis.Analyzer;
import org.apache.lucene.analysis.SimpleAnalyzer;

import baldr.Definitions;
import baldr.DocumentAnalyzer;


public class TermsInIndex {
	public static ArrayList<String> files = new ArrayList<String>();
	public static HashSet<String> files2 = new HashSet<String>();
	
	public static void main(String[] args) throws IOException {
		//String indexDir = Definitions.indexDir_bigram_10;
		String indexDir = Definitions.indexDir_bigram_100;
		Directory directory = null;
		IndexWriter iwriter = null;
		IndexReader ireader = null;
		int count = 0;
		//Analyzer analyzer = new DocumentAnalyzer(DocumentAnalyzer.Filters.PhraseFilter3);

		try {
		    directory = FSDirectory.getDirectory(indexDir);
		} catch(IOException e) {
		    e.printStackTrace();
		    System.exit(0);
		}

		try {
		    // adds 'false', so that the already existing index is erased.
			/*
		    iwriter = new IndexWriter(directory, analyzer, false);
		    iwriter.setUseCompoundFile(false); */
			
			//ireader = new IndexReader(directory);
			ireader = IndexReader.open(directory);
			TermEnum te = ireader.terms();
			te.next();
			Term t;
			
			while( (t = te.term()) != null ) {
				count += 1;
				te.next();
			}
			System.out.println();
			
		    

		} catch(IOException e) {
		    e.printStackTrace();
		    System.exit(0);
		}
		System.out.println("Done reading index. Have: "+count+" terms in index. Closing index.");
		ireader.close();
		System.exit(0);
		
		//String[] dirs = new String[] {"GX000", "GX001", "GX002", "GX003", "GX004", "GX005", "GX006", "GX007", "GX008", "GX009"};
		//String maindir = Definitions.baseDir;
		//
		//for(String dir : dirs) {
		//	fetchFiles(maindir+File.separator+dir);
		//}
		//
		//String[] partPath;
		//String trecCat, fileNo;
		//
		//String thisDir = System.getProperty("user.dir");
		////System.out.println("This dir: "+thisDir);
		//String homeDir = System.getProperty("user.home");
		//
		//
		//
		//for(String t : files) {
		//	partPath = t.split("/");
		//	
		//	trecCat = partPath[5];
		//	fileNo = partPath[6];
		//	
		//	files2.add(trecCat+"/"+fileNo);
		//}
		//System.out.println("Has "+files2.size()+" files in memory");
		//
		////Properties p = System.getProperties();
		//
		////Map<String, String> tmp = System.getenv();
		////for(Object t: p.keySet()) {
		////	System.out.println("Key: "+(String)t+" Value:"+p.get(t));
		////}
		//File outFile = new File(thisDir+File.separator+"trecFiles.txt");
		////BufferedOutputStream bos = new BufferedOutputStream( new FileWriter(outFile) );
		//BufferedWriter bw = new BufferedWriter(new FileWriter(outFile));
		//for(String t : files2) {
		//	bw.write(t+"\n");
		//}
		//bw.close();
		//System.out.println("Done");
		
		System.exit(0);
	}
	
	private static void fetchFiles(String dirName) throws IOException {
    	File[] filer;
    	
    	File dir = new File(dirName);
    	filer = dir.listFiles();
    	for(File f : filer) {
    		/********* DEBUGGING **********/
    		if(files.size() == 1000) break; /* Debugging!!!!*/
    		/********* DEBUGGING **********/
    		
    		if(f.isDirectory()) {
    			/* Recursion! Needed to iterate down the path hierarchy! */
    			fetchFiles(f.toString());
    			continue;
    		}
    		files.add(f.getAbsolutePath());
    	}
    }
}
