package baldr.utility;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;

import org.apache.log4j.Level;
import org.apache.log4j.Logger;

import baldr.Definitions;

//import it.unimi.dsi.mg4j.util.MutableString;


public class TestReadFile
{
    private Logger logger = Logger.getLogger(this.getClass());
    private ArrayList<String> files = new ArrayList<String>();

    private long start = 0;
    private long stop = 0;


    public TestReadFile() {
    	logger.setLevel(Level.DEBUG);
    }

    public void init() {
	logger.debug("aight..");
	//File f = new File("/home/fellingh/skole/trec_gov2/GX000/00");
	//fetchFile(f);
	fetchTRECFiles(Definitions.trecFile);
	File tmp;

	HashSet<Long> results = new HashSet<Long>();

	for(String f : files) {
	    tmp = new File(f);
	    fetchFile(tmp);
	    //logger.debug("Diff: "+(stop-start));
	    results.add( (stop-start) );
	}

	logger.debug("Has read "+files.size()+" files");
	long average = 0L;
	long result_sum = 0L;

	for(Long t : results) {
	    result_sum = result_sum+t;
	}
	average = (result_sum/results.size());

	logger.debug("Average diff: "+average+" ms");
	logger.debug("Quit..");
    }

    private void fetchFile(File trecFile) {
	if (!trecFile.isFile()) {
	    logger.error("Could not open: "+trecFile.getPath()+". Need this file to determine ");
	    return;
	}

	try {
	    StringBuilder mt = new StringBuilder();
	    String t;

	    start = System.currentTimeMillis();
	    BufferedReader in = new BufferedReader(new FileReader(trecFile));
	    
	    while( (t = in.readLine()) != null) {
		mt.append(t);
	    }
	    stop = System.currentTimeMillis();

	} catch(IOException e) {
	    e.printStackTrace();
	}
    }

    private void fetchTRECFiles(File trecFile) {	
		if(!trecFile.isFile()) {
			logger.error("Could not open: "+trecFile.getPath()+". Need this file to determine ");
			return;
		}
		File tmpFile;
		
		try {
			BufferedReader in = new BufferedReader(new FileReader(trecFile));
			String t = "";
			while( (t = in.readLine()) != null) {
				files.add(Definitions.baseDir+File.separator+t.replace("\n", ""));
			}
		} catch(IOException e) {
			e.printStackTrace();
		}
		
	}

    public static void main(String[] args) {
	System.out.println("YEAH");
	TestReadFile trf = new TestReadFile();
	trf.init();
    }
}
